//+------------------------------------------------------------------+
//|                                        Perevertysh20240512-1.mq5 |
//|                                                          Voronin |
//|                                      Virtual Trailing Stop 2.mq5 |
//|                              Copyright © 2020, Vladimir Karputov |
//|                     https://www.mql5.com/ru/market/product/43516 |
//|                                           http://wmua.ru/slesar/ |
//|                                                           Gerbut |
//|                                           andriygerbut@gmail.com |
//+------------------------------------------------------------------+
#property version   "1.00"
#property version   "1.000"
#property strict

// Libraries:
//+------------------------------------------------------------------+
#include <Trade\Trade.mqh>
#include <Trade\SymbolInfo.mqh>
#include <Trade\PositionInfo.mqh>
//#include <SecAuxLib.mqh>
#include <MT4Orders.mqh>

CPositionInfo     k_pos;
CSymbolInfo       m_symbol;
CTrade            m_trade;

//+------------------------------------------------------------------+
// Input parameters:
//+------------------------------------------------------------------+
enum ENUM_SYMBOL
{
    EURUSD  = 0,
    GPBUSD  = 1,
    USDCHF  = 2,
    BTCUSD  = 3,
    USDCAD  = 4,
    AUDCAD  = 5,
    NAZUSD  = 6,
    AUDCHF  = 7,
    AUDJPY  = 8,
    AUDUSD  = 9,
    BITCOIN = 10,
    XAUUSD  = 11,
    XAGUSD  = 12
};
input ENUM_SYMBOL     SYMBOL;
input ENUM_TIMEFRAMES TimeFrame       = PERIOD_CURRENT;
input double          LotSize         = 0.01; 
input ulong           Magic_m         = 9191;        // M1-9991,H1-9960,H4-9240,D2-1440,perevertysh-9191
input ulong           InpDeviation    = 10;          // Deviation, in points (1.00045-1.00055=10 points)
input ulong           spredVol        = 4;           // во сколько раз волатильность должна быть выше спреда
//+------------------------------------------------------------------+
double   SymbolPoint                  = SymbolInfoDouble(Symbol(),SYMBOL_POINT); // значение пункта цены
double   ask                          = NormalizeDouble(SymbolInfoDouble(Symbol(), SYMBOL_ASK),_Digits);
double   bid                          = NormalizeDouble(SymbolInfoDouble(Symbol(), SYMBOL_BID),_Digits);
//double   spred                        = NormalizeDouble(SymbolInfoInteger(Symbol(),SYMBOL_SPREAD),_Digits);
//double   PerSpread                    = ((ask - bid) / ask) * 100;                          // Процент спреда
//double   PerVolatiliti                = SymbolInfoDouble(Symbol(),SYMBOL_PRICE_VOLATILITY); // Процент волатильности - не работает в mql5!
double   Tick_Size                    = SymbolInfoDouble(Symbol(),SYMBOL_TRADE_TICK_SIZE); // минимально возможное изменение цены
ulong    m_position_ticket            = 0;
ulong    ClosedTicket                 = 0;
MqlTradeRequest m_request;                            // структура торгового запроса
MqlTradeResult m_result;                              // структура результата торгового запроса
double   m_adjusted_point;                            // point value adjusted for 3 or 5 points
ulong    MS                           = 1000;
ulong    TFMS                         = PeriodSeconds(/*Period()*/ PERIOD_M1) * MS;

//+------------------------------------------------------------------+
// Methods-Events:                                                   |
//+------------------------------------------------------------------+
int OnInit()
{
   m_trade.SetExpertMagicNumber(Magic_m);
   if(!m_symbol.Name(Symbol()))                                                 // sets symbol name
     {
      Print(__FILE__," ",__FUNCTION__,", ERROR: CSymbolInfo.Name");
      return(INIT_FAILED);
     }
   RefreshRates();
//---
   m_trade.SetMarginMode();
   m_trade.SetTypeFillingBySymbol(m_symbol.Name());
   m_trade.SetDeviationInPoints(InpDeviation);

   m_adjusted_point             = SymbolPoint;                                     //m_symbol.Point()*digits_adjust;
//---
        EventSetMillisecondTimer(100);
        return (INIT_SUCCEEDED);
}
    
void OnTick()
{
   OnTimer();
}

void OnTimer()
{
   /*int         total            = PositionsTotal();
   for(int i=total-2; i>=0; i--)
   {
      k_pos.SelectByIndex(i);
      mposition_ticket = PositionGetTicket(i);
      string m_position_symbol       = k_pos.Symbol();
      long   m_position_magic        = k_pos.Magic();
      Print("total = ",(string)total,", mposition_ticket = ",(string)mposition_ticket,", m_position_magic = ",(string)m_position_magic);*/
        MqlTradeRequest tradeRequest = { };
        MqlTick last_tick;
        MqlTick current_tick;
        SymbolInfoTick(Symbol(),last_tick);
        SymbolInfoTick(Symbol(),current_tick);
        double ask0             = current_tick.ask;                               //SymbolInfoDouble(Symbol(), SYMBOL_ASK);
        double bid0             = current_tick.bid;
        double spred            = ask0 - bid0;
        ulong  time0            = current_tick.time_msc;
        ulong  timeOpen         = PositionGetInteger(POSITION_TIME_MSC);
        ENUM_POSITION_TYPE Type = (ENUM_POSITION_TYPE)PositionGetInteger(POSITION_TYPE); // тип позиции
        double Price            = PositionGetDouble(POSITION_PRICE_OPEN);
        double Tp               = PositionGetDouble(POSITION_TP);
        m_position_ticket       = PositionGetInteger(POSITION_TICKET);
        double lt               = PositionGetDouble(POSITION_VOLUME); // объем позиции
        ulong  magic            = PositionGetInteger(POSITION_MAGIC); // MagicNumber позиции
double VolatilitiUp1            = 0;
double VolatilitiUp2            = 0;
double VolatilitiUp3            = 0;
double VolatilitiUp4            = 0;
double VolatilitiUp5            = 0;
double VolatilitiUp6            = 0;
double VolatilitiLow1           = 0;
double VolatilitiLow2           = 0;
double VolatilitiLow3           = 0;
double VolatilitiLow4           = 0;
double VolatilitiLow5           = 0;
double VolatilitiLow6           = 0;
double Volatiliti               = 0;
double ask1                     = 0;
double ask2                     = 0;
double ask3                     = 0;
double ask4                     = 0;
double ask5                     = 0;
double ask6                     = 0;
double bid1                     = 0;
double bid2                     = 0;
double bid3                     = 0;
double bid4                     = 0;
double bid5                     = 0;
double bid6                     = 0;
double   PriceArr[]; // Создание массива цен
ArraySetAsSeries(PriceArr, true); // Сортировка данных
int      ATRDef                 = iATR(_Symbol,_Period,6); // определение ATR
CopyBuffer(ATRDef,0,0,3,PriceArr); // определяем данные и сохраняем результат
double   ATRValue               = NormalizeDouble(PriceArr[0],_Digits); // Получаем значения текущих данных
MqlTick ticks[];
MqlTick tick;
SymbolInfoTick(Symbol(),tick);
  MqlTick mqlTick1[], symbTick1; // объявили переменные
  SymbolInfoTick(_Symbol, symbTick1); // это последний тик
  int copied1 = CopyTicksRange(_Symbol, mqlTick1, COPY_TICKS_INFO, symbTick1.time_msc, symbTick1.time_msc-10000); // цены за последние 10 секунд
  double bid_arr1[];
  ArrayResize(bid_arr1,copied1,100000);
  double ask_arr1[];
  ArrayResize(ask_arr1,copied1,100000);
  for(int i = 0; i < copied1; i++)
  {
            bid_arr1[i] = mqlTick1[i].bid;
            ask_arr1[i] = mqlTick1[i].ask;
            bid1        = NormalizeDouble(bid_arr1[0], _Digits); // первая цена bid за последние 10 секунд (аналог открытия текущего или закрытия предыдущего периода)
            ask1        = NormalizeDouble(ask_arr1[0], _Digits); // первая цена ask за последние 10 секунд (аналог открытия текущего или закрытия предыдущего периода)
     int    IndMaxBid   = ArrayMaximum(bid_arr1, 0, ArraySize(bid_arr1)-1);      // Индекс элемента массива bid_arr1 с максимальной ценой
     double highestBid  = bid_arr1[IndMaxBid];                      // Самая высокая цена bid за последние 10 секунд
     int    IndMinBid   = ArrayMinimum(bid_arr1, 0, ArraySize(bid_arr1)-1);      // Индекс элемента массива bid_arr1 с минимальной ценой
     double lowestBid   = bid_arr1[IndMinBid];                      // Самая низкая цена bid за последние 10 секунд
     int    IndMaxAsk   = ArrayMaximum(ask_arr1, 0, ArraySize(ask_arr1)-1);      // Индекс элемента массива ask_arr1 с максимальной ценой
     double highestAsk  = ask_arr1[IndMaxAsk];                      // Самая высокая цена ask за последние 10 секунд
     int    IndMinAsk   = ArrayMinimum(ask_arr1, 0, ArraySize(ask_arr1)-1);      // Индекс элемента массива ask_arr1 с минимальной ценой
     double lowestAsk   = ask_arr1[IndMinAsk];                      // Самая низкая цена ask за последние 10 секунд
     double highestHigh = (highestBid+highestAsk)/2;               // Средняя наибольшего ask и наибольшего bid элемента
     double lowestLow   = (lowestBid+lowestAsk)/2;                 // Средняя наименьшего ask и наименьшего bid элемента
     if(highestHigh - (ask0 + bid0 + bid1 + ask1)/4 >= (ask0 + bid0 + bid1 + ask1)/4 - lowestLow)
     {
        VolatilitiUp1 = NormalizeDouble(highestHigh - (ask0 + bid0 + bid1 + ask1)/4, _Digits);
        VolatilitiLow1 = 0;
     }
     else if(highestHigh - (ask0 + bid0 + bid1 + ask1)/4 < (ask0 + bid0 + bid1 + ask1)/4 - lowestLow)
     {
        VolatilitiLow1 = NormalizeDouble((ask0 + bid0 + bid1 + ask1)/4 - lowestLow, _Digits);
        VolatilitiUp1 = 0;
     }
  }
  MqlTick mqlTick2[], symbTick2; // объявили переменные
  SymbolInfoTick(_Symbol, symbTick2); // это последний тик
  int copied2 = CopyTicksRange(_Symbol, mqlTick2, COPY_TICKS_INFO, symbTick2.time_msc-10000, symbTick2.time_msc-20000); // цены между 10 секунд и 20 секунд назад
  double bid_arr2[];
  ArrayResize(bid_arr2,copied2,100000);
  double ask_arr2[];
  ArrayResize(ask_arr2,copied2,100000);
  for(int i = 0; i < copied2; i++)
  {
            bid_arr2[i] = mqlTick2[i].bid;
            ask_arr2[i] = mqlTick2[i].ask;
            bid2        = NormalizeDouble(bid_arr2[0], _Digits); // первая цена bid между 10 секунд и 20 секунд назад (аналог открытия текущего или закрытия предыдущего периода)
            ask2        = NormalizeDouble(ask_arr2[0], _Digits); // первая цена ask между 10 секунд и 20 секунд назад (аналог открытия текущего или закрытия предыдущего периода)
     int    IndMaxBid   = ArrayMaximum(bid_arr2, 0, ArraySize(bid_arr2)-1);      // Индекс элемента массива bid_arr2 с максимальной ценой
     double highestBid  = bid_arr2[IndMaxBid];                      // Самая высокая цена bid между 10 секунд и 20 секунд назад
     int    IndMinBid   = ArrayMinimum(bid_arr2, 0, ArraySize(bid_arr2)-1);      // Индекс элемента массива bid_arr2 с минимальной ценой
     double lowestBid   = bid_arr2[IndMinBid];                      // Самая низкая цена bid между 10 секунд и 20 секунд назад
     int    IndMaxAsk   = ArrayMaximum(ask_arr2, 0, ArraySize(ask_arr2)-1);      // Индекс элемента массива ask_arr2 с максимальной ценой
     double highestAsk  = ask_arr2[IndMaxAsk];                      // Самая высокая цена ask между 10 секунд и 20 секунд назад
     int    IndMinAsk   = ArrayMinimum(ask_arr2, 0, ArraySize(ask_arr2)-1);      // Индекс элемента массива ask_arr2 с минимальной ценой
     double lowestAsk   = ask_arr2[IndMinAsk];                      // Самая низкая цена ask между 20 секунд и 20 секунд назад
     double highestHigh = (highestBid+highestAsk)/2;               // Средняя наибольшего ask и наибольшего bid элемента
     double lowestLow   = (lowestBid+lowestAsk)/2;                 // Средняя наименьшего ask и наименьшего bid элемента
     if(highestHigh - (ask1 + bid1 + bid2 + ask2)/4 >= (ask1 + bid1 + bid2 + ask2)/4)
     {
        VolatilitiUp2 = NormalizeDouble(highestHigh - (ask1 + bid1 + bid2 + ask2)/4, _Digits);
        VolatilitiLow2 = 0;
     }
     else if(highestHigh - (ask1 + bid1 + bid2 + ask2)/4 < (ask1 + bid1 + bid2 + ask2)/4 - lowestLow)
     {
        VolatilitiLow2 = NormalizeDouble((ask1 + bid1 + bid2 + ask2)/4 - lowestLow, _Digits);
        VolatilitiUp2 = 0;
     }
  }
  MqlTick mqlTick3[], symbTick3; // объявили переменные
  SymbolInfoTick(_Symbol, symbTick3); // это последний тик
  int copied3 = CopyTicksRange(_Symbol, mqlTick3, COPY_TICKS_INFO, symbTick3.time_msc-20000, symbTick3.time_msc-30000); // цены между 20 секунд и 30 секунд назад
  double bid_arr3[];
  ArrayResize(bid_arr3,copied3,100000);
  double ask_arr3[];
  ArrayResize(ask_arr3,copied3,100000);
  for(int i = 0; i < copied3; i++)
  {
            bid_arr3[i] = mqlTick3[i].bid;
            ask_arr3[i] = mqlTick3[i].ask;
            bid3        = NormalizeDouble(bid_arr3[0], _Digits); // первая цена bid между 20 секунд и 30 секунд назад (аналог открытия текущего или закрытия предыдущего периода)
            ask3        = NormalizeDouble(ask_arr3[0], _Digits); // первая цена ask между 20 секунд и 30 секунд назад (аналог открытия текущего или закрытия предыдущего периода)
     int    IndMaxBid   = ArrayMaximum(bid_arr3, 0, ArraySize(bid_arr3)-1);      // Индекс элемента массива bid_arr3 с максимальной ценой
     double highestBid  = bid_arr3[IndMaxBid];                      // Самая высокая цена bid между 10 секунд и 30 секунд назад
     int    IndMinBid   = ArrayMinimum(bid_arr3, 0, ArraySize(bid_arr3)-1);      // Индекс элемента массива bid_arr3 с минимальной ценой
     double lowestBid   = bid_arr3[IndMinBid];                      // Самая низкая цена bid между 20 секунд и 30 секунд назад
     int    IndMaxAsk   = ArrayMaximum(ask_arr3, 0, ArraySize(ask_arr3)-1);      // Индекс элемента массива ask_arr3 с максимальной ценой
     double highestAsk  = ask_arr3[IndMaxAsk];                      // Самая высокая цена ask между 20 секунд и 30 секунд назад
     int    IndMinAsk   = ArrayMinimum(ask_arr3, 0, ArraySize(ask_arr3)-1);      // Индекс элемента массива ask_arr3 с минимальной ценой
     double lowestAsk   = ask_arr3[IndMinAsk];                      // Самая низкая цена ask между 20 секунд и 30 секунд назад
     double highestHigh = (highestBid+highestAsk)/2;               // Средняя наибольшего ask и наибольшего bid элемента
     double lowestLow   = (lowestBid+lowestAsk)/2;                 // Средняя наименьшего ask и наименьшего bid элемента
     if(highestHigh - (ask2 + bid2 + bid3 + ask3)/4 >= (ask2 + bid2 + bid3 + ask3)/4 - lowestLow)
     {
        VolatilitiUp3 = NormalizeDouble(highestHigh - (ask2 + bid2 + bid3 + ask3)/4, _Digits);
        VolatilitiLow3 = 0;
     }
     else if(highestHigh - (ask2 + bid2 + bid3 + ask3)/4 < (ask2 + bid2 + bid3 + ask3)/4 - lowestLow)
     {
        VolatilitiLow3 = NormalizeDouble((ask2 + bid2 + bid3 + ask3)/4 - lowestLow, _Digits);
        VolatilitiUp3 = 0;
     }
  }
  MqlTick mqlTick4[], symbTick4; // объявили переменные
  SymbolInfoTick(_Symbol, symbTick4); // это последний тик
  int copied4 = CopyTicksRange(_Symbol, mqlTick4, COPY_TICKS_INFO, symbTick4.time_msc-30000, symbTick4.time_msc-40000); // цены между 30 секунд и 40 секунд назад
  double bid_arr4[];
  ArrayResize(bid_arr4,copied4,100000);
  double ask_arr4[];
  ArrayResize(ask_arr4,copied4,100000);
  for(int i = 0; i < copied4; i++)
  {
            bid_arr4[i] = mqlTick4[i].bid;
            ask_arr4[i] = mqlTick4[i].ask;
            bid4        = NormalizeDouble(bid_arr4[0], _Digits); // первая цена bid между 30 секунд и 40 секунд назад (аналог открытия текущего или закрытия предыдущего периода)
            ask4        = NormalizeDouble(ask_arr4[0], _Digits); // первая цена ask между 30 секунд и 40 секунд назад (аналог открытия текущего или закрытия предыдущего периода)
     int    IndMaxBid   = ArrayMaximum(bid_arr4, 0, ArraySize(bid_arr4)-1);      // Индекс элемента массива bid_arr4 с максимальной ценой
     double highestBid  = bid_arr4[IndMaxBid];                      // Самая высокая цена bid между 30 секунд и 40 секунд назад
     int    IndMinBid   = ArrayMinimum(bid_arr4, 0, ArraySize(bid_arr4)-1);      // Индекс элемента массива bid_arr4 с минимальной ценой
     double lowestBid   = bid_arr4[IndMinBid];                      // Самая низкая цена bid между 30 секунд и 40 секунд назад
     int    IndMaxAsk   = ArrayMaximum(ask_arr4, 0, ArraySize(ask_arr4)-1);      // Индекс элемента массива ask_arr4 с максимальной ценой
     double highestAsk  = ask_arr4[IndMaxAsk];                      // Самая высокая цена ask между 30 секунд и 40 секунд назад
     int    IndMinAsk   = ArrayMinimum(ask_arr4, 0, ArraySize(ask_arr4)-1);      // Индекс элемента массива ask_arr4 с минимальной ценой
     double lowestAsk   = ask_arr4[IndMinAsk];                      // Самая низкая цена ask между 30 секунд и 40 секунд назад
     double highestHigh = (highestBid+highestAsk)/2;               // Средняя наибольшего ask и наибольшего bid элемента
     double lowestLow   = (lowestBid+lowestAsk)/2;                 // Средняя наименьшего ask и наименьшего bid элемента
     if(highestHigh - (ask3 + bid3 + bid4 + ask4)/4 >= (ask3 + bid3 + bid4 + ask4)/4 - lowestLow)
     {
        VolatilitiUp4 = NormalizeDouble(highestHigh - (ask3 + bid3 + bid4 + ask4)/4, _Digits);
        VolatilitiLow4 = 0;
     }
     else if(highestHigh - (ask3 + bid3 + bid4 + ask4)/4 < (ask3 + bid3 + bid4 + ask4)/4 - lowestLow)
     {
        VolatilitiLow4 = NormalizeDouble((ask3 + bid3 + bid4 + ask4)/4 - lowestLow, _Digits);
        VolatilitiUp4 = 0;
     }
  }
  MqlTick mqlTick5[], symbTick5; // объявили переменные
  SymbolInfoTick(_Symbol, symbTick5); // это последний тик
  int copied5 = CopyTicksRange(_Symbol, mqlTick5, COPY_TICKS_INFO, symbTick5.time_msc-40000, symbTick5.time_msc-50000); // цены между 40 секунд и 50 секунд назад
  double bid_arr5[];
  ArrayResize(bid_arr5,copied5,100000);
  double ask_arr5[];
  ArrayResize(ask_arr5,copied5,100000);
  for(int i = 0; i < copied5; i++)
  {
            bid_arr5[i] = mqlTick5[i].bid;
            ask_arr5[i] = mqlTick5[i].ask;
            bid5        = NormalizeDouble(bid_arr5[0], _Digits); // первая цена bid между 40 секунд и 50 секунд назад (аналог открытия текущего или закрытия предыдущего периода)
            ask5        = NormalizeDouble(ask_arr5[0], _Digits); // первая цена ask между 40 секунд и 50 секунд назад (аналог открытия текущего или закрытия предыдущего периода)
     int    IndMaxBid   = ArrayMaximum(bid_arr5, 0, ArraySize(bid_arr5)-1);      // Индекс элемента массива bid_arr5 с максимальной ценой
     double highestBid  = bid_arr5[IndMaxBid];                      // Самая высокая цена bid между 40 секунд и 50 секунд назад
     int    IndMinBid   = ArrayMinimum(bid_arr5, 0, ArraySize(bid_arr5)-1);      // Индекс элемента массива bid_arr5 с минимальной ценой
     double lowestBid   = bid_arr5[IndMinBid];                      // Самая низкая цена bid между 40 секунд и 50 секунд назад
     int    IndMaxAsk   = ArrayMaximum(ask_arr5, 0, ArraySize(ask_arr5)-1);      // Индекс элемента массива ask_arr5 с максимальной ценой
     double highestAsk  = ask_arr5[IndMaxAsk];                      // Самая высокая цена ask между 40 секунд и 50 секунд назад
     int    IndMinAsk   = ArrayMinimum(ask_arr5, 0, ArraySize(ask_arr5)-1);      // Индекс элемента массива ask_arr5 с минимальной ценой
     double lowestAsk   = ask_arr5[IndMinAsk];                      // Самая низкая цена ask между 40 секунд и 50 секунд назад
     double highestHigh = (highestBid+highestAsk)/2;               // Средняя наибольшего ask и наибольшего bid элемента
     double lowestLow   = (lowestBid+lowestAsk)/2;                 // Средняя наименьшего ask и наименьшего bid элемента
     if(highestHigh - (ask4 + bid4 + bid5 + ask5)/4 >= (ask4 + bid4 + bid5 + ask5)/4 - lowestLow)
     {
        VolatilitiUp5 = NormalizeDouble(highestHigh - (ask4 + bid4 + bid5 + ask5)/4, _Digits);
        VolatilitiLow5 = 0;
     }
     else if(highestHigh - (ask4 + bid4 + bid5 + ask5)/4 < (ask4 + bid4 + bid5 + ask5)/4 - lowestLow)
     {
        VolatilitiLow5 = NormalizeDouble((ask4 + bid4 + bid5 + ask5)/4 - lowestLow, _Digits);
        VolatilitiUp5 = 0;
     }
  }
  MqlTick mqlTick6[], symbTick6; // объявили переменные
  SymbolInfoTick(_Symbol, symbTick6); // это последний тик
  int copied6 = CopyTicksRange(_Symbol, mqlTick6, COPY_TICKS_INFO, symbTick6.time_msc-50000, symbTick6.time_msc-60000); // цены между 50 секунд и 60 секунд назад
  double bid_arr6[];
  ArrayResize(bid_arr6,copied6,100000);
  double ask_arr6[];
  ArrayResize(ask_arr6,copied6,100000);
  for(int i = 0; i < copied6; i++)
  {
            bid_arr6[i] = mqlTick6[i].bid;
            ask_arr6[i] = mqlTick6[i].ask;
            bid6        = NormalizeDouble(bid_arr6[0], _Digits); // первая цена bid между 50 секунд и 60 секунд назад (аналог открытия текущего или закрытия предыдущего периода)
            ask6        = NormalizeDouble(ask_arr6[0], _Digits); // первая цена ask между 50 секунд и 60 секунд назад (аналог открытия текущего или закрытия предыдущего периода)
     int    IndMaxBid   = ArrayMaximum(bid_arr6, 0, ArraySize(bid_arr6)-1);      // Индекс элемента массива bid_arr6 с максимальной ценой
     double highestBid  = bid_arr6[IndMaxBid];                      // Самая высокая цена bid между 50 секунд и 60 секунд назад
     int    IndMinBid   = ArrayMinimum(bid_arr6, 0, ArraySize(bid_arr6)-1);      // Индекс элемента массива bid_arr6 с минимальной ценой
     double lowestBid   = bid_arr6[IndMinBid];                      // Самая низкая цена bid между 50 секунд и 60 секунд назад
     int    IndMaxAsk   = ArrayMaximum(ask_arr6, 0, ArraySize(ask_arr6)-1);      // Индекс элемента массива ask_arr6 с максимальной ценой
     double highestAsk  = ask_arr6[IndMaxAsk];                      // Самая высокая цена ask между 50 секунд и 60 секунд назад
     int    IndMinAsk   = ArrayMinimum(ask_arr6, 0, ArraySize(ask_arr6)-1);      // Индекс элемента массива ask_arr6 с минимальной ценой
     double lowestAsk   = ask_arr6[IndMinAsk];                      // Самая низкая цена ask между 50 секунд и 60 секунд назад
     double highestHigh = (highestBid+highestAsk)/2;               // Средняя наибольшего ask и наибольшего bid элемента
     double lowestLow   = (lowestBid+lowestAsk)/2;                 // Средняя наименьшего ask и наименьшего bid элемента
     if(highestHigh - (ask5 + bid5 + bid6 + ask6)/4 >= (ask5 + bid5 + bid6 + ask6)/4 - lowestLow)
     {
        VolatilitiUp6 = NormalizeDouble(highestHigh - (ask5 + bid5 + bid6 + ask6)/4, _Digits);
        VolatilitiLow6 = 0;
     }
     else if(highestHigh - (ask5 + bid5 + bid6 + ask6)/4 < (ask5 + bid5 + bid6 + ask6)/4 - lowestLow)
     {
        VolatilitiLow6 = NormalizeDouble((ask5 + bid5 + bid6 + ask6)/4 - lowestLow, _Digits);
        VolatilitiUp6 = 0;
     }
  }
if(VolatilitiLow1>0&&VolatilitiLow2>0&&VolatilitiLow3>0&&VolatilitiLow4>0&&VolatilitiLow5>0&&VolatilitiLow6>0)
{
   double Volatiliti=NormalizeDouble((VolatilitiLow1+VolatilitiLow2+VolatilitiLow3+VolatilitiLow4+VolatilitiLow5+VolatilitiLow6), _Digits);
}
if(VolatilitiLow1>0&&VolatilitiLow2>0&&VolatilitiLow3>0&&VolatilitiLow4>0&&VolatilitiLow5>0&&VolatilitiLow6==0)
{
   double Array1[2]={(VolatilitiLow1+VolatilitiLow2+VolatilitiLow3+VolatilitiLow4+VolatilitiLow5),VolatilitiUp6};
   int IndMax=ArrayMaximum(Array1,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array1[IndMax], _Digits);
}
if(VolatilitiLow1>0&&VolatilitiLow2>0&&VolatilitiLow3>0&&VolatilitiLow4>0&&VolatilitiLow5==0&&VolatilitiLow6>0)
{
   double Array2[3]={(VolatilitiLow1+VolatilitiLow2+VolatilitiLow3+VolatilitiLow4),VolatilitiUp5,VolatilitiLow6};
   int IndMax=ArrayMaximum(Array2,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array2[IndMax], _Digits);
}
if(VolatilitiLow1>0&&VolatilitiLow2>0&&VolatilitiLow3>0&&VolatilitiLow4>0&&VolatilitiLow5==0&&VolatilitiLow6==0)
{
   double Array3[2]={(VolatilitiLow1+VolatilitiLow2+VolatilitiLow3+VolatilitiLow4),(VolatilitiUp5+VolatilitiUp6)};
   int IndMax=ArrayMaximum(Array3,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array3[IndMax], _Digits);
}
if(VolatilitiLow1>0&&VolatilitiLow2>0&&VolatilitiLow3>0&&VolatilitiLow4==0&&VolatilitiLow5>0&&VolatilitiLow6>0)
{
   double Array4[3]={(VolatilitiLow2+VolatilitiLow2+VolatilitiLow3),VolatilitiUp4,(VolatilitiLow5+VolatilitiLow6)};
   int IndMax=ArrayMaximum(Array4,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array4[IndMax], _Digits);
}
if(VolatilitiLow1>0&&VolatilitiLow2>0&&VolatilitiLow3>0&&VolatilitiLow4==0&&VolatilitiLow5>0&&VolatilitiLow6==0)
{
   double Array5[4]={(VolatilitiLow1+VolatilitiLow2+VolatilitiLow3),VolatilitiUp4,VolatilitiLow5,VolatilitiUp6};
   int IndMax=ArrayMaximum(Array5,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array5[IndMax], _Digits);
}
if(VolatilitiLow1>0&&VolatilitiLow2>0&&VolatilitiLow3>0&&VolatilitiLow4==0&&VolatilitiLow5==0&&VolatilitiLow6>0)
{
   double Array6[3]={(VolatilitiLow1+VolatilitiLow2+VolatilitiLow3),(VolatilitiUp4+VolatilitiUp5),VolatilitiLow6};
   int IndMax=ArrayMaximum(Array6,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array6[IndMax], _Digits);
}
if(VolatilitiLow1>0&&VolatilitiLow2>0&&VolatilitiLow3>0&&VolatilitiLow4==0&&VolatilitiLow5==0&&VolatilitiLow6==0)
{
   double Array7[2]={(VolatilitiLow1+VolatilitiLow2+VolatilitiLow3),(VolatilitiUp4+VolatilitiUp5+VolatilitiUp6)};
   int IndMax=ArrayMaximum(Array7,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array7[IndMax], _Digits);
}
if(VolatilitiLow1>0&&VolatilitiLow2>0&&VolatilitiLow3==0&&VolatilitiLow4>0&&VolatilitiLow5>0&&VolatilitiLow6>0)
{
   double Array8[3]={(VolatilitiLow1+VolatilitiLow2),VolatilitiUp3,(VolatilitiLow4+VolatilitiLow5+VolatilitiLow6)};
   int IndMax=ArrayMaximum(Array8,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array8[IndMax], _Digits);
}
if(VolatilitiLow1>0&&VolatilitiLow2>0&&VolatilitiLow3==0&&VolatilitiLow4>0&&VolatilitiLow5>0&&VolatilitiLow6==0)
{
   double Array9[4]={(VolatilitiLow1+VolatilitiLow2),VolatilitiUp3,(VolatilitiLow4+VolatilitiLow5),VolatilitiUp6};
   int IndMax=ArrayMaximum(Array9,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array9[IndMax], _Digits);
}
if(VolatilitiLow1>0&&VolatilitiLow2>0&&VolatilitiLow3==0&&VolatilitiLow4>0&&VolatilitiLow5==0&&VolatilitiLow6>0)
{
   double Array10[5]={(VolatilitiLow1+VolatilitiLow2),VolatilitiUp3,VolatilitiLow4,VolatilitiUp5,VolatilitiLow6};
   int IndMax=ArrayMaximum(Array10,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array10[IndMax], _Digits);
}
if(VolatilitiLow1>0&&VolatilitiLow2>0&&VolatilitiLow3==0&&VolatilitiLow4>0&&VolatilitiLow5==0&&VolatilitiLow6==0)
{
   double Array11[4]={(VolatilitiLow1+VolatilitiLow2),VolatilitiUp3,VolatilitiLow4,(VolatilitiUp5+VolatilitiUp6)};
   int IndMax=ArrayMaximum(Array11,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array11[IndMax], _Digits);
}
if(VolatilitiLow1>0&&VolatilitiLow2>0&&VolatilitiLow3==0&&VolatilitiLow4==0&&VolatilitiLow5>0&&VolatilitiLow6>0)
{
   double Array12[3]={(VolatilitiLow1+VolatilitiLow2),(VolatilitiUp3+VolatilitiUp4),(VolatilitiLow5+VolatilitiLow6)};
   int IndMax=ArrayMaximum(Array12,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array12[IndMax], _Digits);
}
if(VolatilitiLow1>0&&VolatilitiLow2>0&&VolatilitiLow3==0&&VolatilitiLow4==0&&VolatilitiLow5>0&&VolatilitiLow6==0)
{
   double Array13[4]={(VolatilitiLow1+VolatilitiLow2),(VolatilitiUp3+VolatilitiUp4),VolatilitiLow5,VolatilitiUp6};
   int IndMax=ArrayMaximum(Array13,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array13[IndMax], _Digits);
}
if(VolatilitiLow1>0&&VolatilitiLow2>0&&VolatilitiLow3==0&&VolatilitiLow4==0&&VolatilitiLow5==0&&VolatilitiLow6>0)
{
   double Array14[3]={(VolatilitiLow1+VolatilitiLow2),(VolatilitiUp3+VolatilitiUp4+VolatilitiUp5),VolatilitiLow6};
   int IndMax=ArrayMaximum(Array14,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array14[IndMax], _Digits);
}
if(VolatilitiLow1>0&&VolatilitiLow2>0&&VolatilitiLow3==0&&VolatilitiLow4==0&&VolatilitiLow5==0&&VolatilitiLow6==0)
{
   double Array15[2]={(VolatilitiLow1+VolatilitiLow2),(VolatilitiUp3+VolatilitiUp4+VolatilitiUp5+VolatilitiUp6)};
   int IndMax=ArrayMaximum(Array15,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array15[IndMax], _Digits);
}
if(VolatilitiLow1>0&&VolatilitiLow2==0&&VolatilitiLow3>0&&VolatilitiLow4>0&&VolatilitiLow5>0&&VolatilitiLow6>0)
{
   double Array16[3]={VolatilitiLow1,VolatilitiUp2,(VolatilitiLow3+VolatilitiLow4+VolatilitiLow5+VolatilitiLow6)};
   int IndMax=ArrayMaximum(Array16,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array16[IndMax], _Digits);
}
if(VolatilitiLow1>0&&VolatilitiLow2==0&&VolatilitiLow3>0&&VolatilitiLow4>0&&VolatilitiLow5>0&&VolatilitiLow6==0)
{
   double Array17[4]={VolatilitiLow1,VolatilitiUp2,(VolatilitiLow3+VolatilitiLow4+VolatilitiLow5),VolatilitiUp6};
   int IndMax=ArrayMaximum(Array17,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array17[IndMax], _Digits);
}
if(VolatilitiLow1>0&&VolatilitiLow2==0&&VolatilitiLow3>0&&VolatilitiLow4>0&&VolatilitiLow5==0&&VolatilitiLow6>0)
{
   double Array18[5]={VolatilitiLow1,VolatilitiUp2,(VolatilitiLow3+VolatilitiLow4),VolatilitiUp5,VolatilitiLow6};
   int IndMax=ArrayMaximum(Array18,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array18[IndMax], _Digits);
}
if(VolatilitiLow1>0&&VolatilitiLow2==0&&VolatilitiLow3>0&&VolatilitiLow4>0&&VolatilitiLow5==0&&VolatilitiLow6==0)
{
   double Array19[4]={VolatilitiLow1,VolatilitiUp2,(VolatilitiLow3+VolatilitiLow4),(VolatilitiUp5+VolatilitiUp6)};
   int IndMax=ArrayMaximum(Array19,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array19[IndMax], _Digits);
}
if(VolatilitiLow1>0&&VolatilitiLow2==0&&VolatilitiLow3>0&&VolatilitiLow4==0&&VolatilitiLow5>0&&VolatilitiLow6>0)
{
   double Array20[5]={VolatilitiLow1,VolatilitiUp2,VolatilitiLow3,VolatilitiUp4,(VolatilitiLow5+VolatilitiLow6)};
   int IndMax=ArrayMaximum(Array20,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array20[IndMax], _Digits);
}
if(VolatilitiLow1>0&&VolatilitiLow2==0&&VolatilitiLow3>0&&VolatilitiLow4==0&&VolatilitiLow5>0&&VolatilitiLow6==0)
{
   double Array21[6]={VolatilitiLow1,VolatilitiUp2,VolatilitiLow3,VolatilitiUp4,VolatilitiLow5,VolatilitiUp6};
   int IndMax=ArrayMaximum(Array21,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array21[IndMax], _Digits);
}
if(VolatilitiLow1>0&&VolatilitiLow2==0&&VolatilitiLow3>0&&VolatilitiLow4==0&&VolatilitiLow5==0&&VolatilitiLow6>0)
{
   double Array22[5]={VolatilitiLow1,VolatilitiUp2,VolatilitiLow3,(VolatilitiUp4+VolatilitiUp5),VolatilitiLow6};
   int IndMax=ArrayMaximum(Array22,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array22[IndMax], _Digits);
}
if(VolatilitiLow1>0&&VolatilitiLow2==0&&VolatilitiLow3>0&&VolatilitiLow4==0&&VolatilitiLow5==0&&VolatilitiLow6==0)
{
   double Array23[4]={VolatilitiLow1,VolatilitiUp2,VolatilitiLow3,(VolatilitiUp4+VolatilitiUp5+VolatilitiUp6)};
   int IndMax=ArrayMaximum(Array23,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array23[IndMax], _Digits);
}
if(VolatilitiLow1>0&&VolatilitiLow2==0&&VolatilitiLow3==0&&VolatilitiLow4>0&&VolatilitiLow5>0&&VolatilitiLow6>0)
{
   double Array24[3]={VolatilitiLow1,(VolatilitiUp2+VolatilitiUp3),(VolatilitiLow4+VolatilitiLow5+VolatilitiLow6)};
   int IndMax=ArrayMaximum(Array24,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array24[IndMax], _Digits);
}
if(VolatilitiLow1>0&&VolatilitiLow2==0&&VolatilitiLow3==0&&VolatilitiLow4>0&&VolatilitiLow5>0&&VolatilitiLow6==0)
{
   double Array25[4]={VolatilitiLow1,(VolatilitiUp2+VolatilitiUp3),(VolatilitiLow4+VolatilitiLow5),VolatilitiUp6};
   int IndMax=ArrayMaximum(Array25,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array25[IndMax], _Digits);
}
if(VolatilitiLow1>0&&VolatilitiLow2==0&&VolatilitiLow3==0&&VolatilitiLow4>0&&VolatilitiLow5==0&&VolatilitiLow6>0)
{
   double Array26[5]={VolatilitiLow1,(VolatilitiUp2+VolatilitiUp3),VolatilitiLow4,VolatilitiUp5,VolatilitiLow6};
   int IndMax=ArrayMaximum(Array26,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array26[IndMax], _Digits);
}
if(VolatilitiLow1>0&&VolatilitiLow2==0&&VolatilitiLow3==0&&VolatilitiLow4>0&&VolatilitiLow5==0&&VolatilitiLow6==0)
{
   double Array27[4]={VolatilitiLow1,(VolatilitiUp2+VolatilitiUp3),VolatilitiLow4,(VolatilitiUp5+VolatilitiUp6)};
   int IndMax=ArrayMaximum(Array27,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array27[IndMax], _Digits);
}
if(VolatilitiLow1>0&&VolatilitiLow2==0&&VolatilitiLow3==0&&VolatilitiLow4==0&&VolatilitiLow5>0&&VolatilitiLow6>0)
{
   double Array28[3]={VolatilitiLow1,(VolatilitiUp2+VolatilitiUp3+VolatilitiUp4),(VolatilitiLow5+VolatilitiLow6)};
   int IndMax=ArrayMaximum(Array28,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array28[IndMax], _Digits);
}
if(VolatilitiLow1>0&&VolatilitiLow2==0&&VolatilitiLow3==0&&VolatilitiLow4==0&&VolatilitiLow5>0&&VolatilitiLow6==0)
{
   double Array29[4]={VolatilitiLow1,(VolatilitiUp2+VolatilitiUp3+VolatilitiUp4),VolatilitiLow5,VolatilitiUp6};
   int IndMax=ArrayMaximum(Array29,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array29[IndMax], _Digits);
}
if(VolatilitiLow1>0&&VolatilitiLow2==0&&VolatilitiLow3==0&&VolatilitiLow4==0&&VolatilitiLow5==0&&VolatilitiLow6>0)
{
   double Array30[3]={VolatilitiLow1,(VolatilitiUp2+VolatilitiUp3+VolatilitiUp4+VolatilitiUp5),VolatilitiLow6};
   int IndMax=ArrayMaximum(Array30,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array30[IndMax], _Digits);
}
if(VolatilitiLow1>0&&VolatilitiLow2==0&&VolatilitiLow3==0&&VolatilitiLow4==0&&VolatilitiLow5==0&&VolatilitiLow6==0)
{
   double Array31[2]={VolatilitiLow1,(VolatilitiUp2+VolatilitiUp3+VolatilitiUp4+VolatilitiUp5+VolatilitiUp6)};
   int IndMax=ArrayMaximum(Array31,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array31[IndMax], _Digits);
}
if(VolatilitiLow1==0&&VolatilitiLow2>0&&VolatilitiLow3>0&&VolatilitiLow4>0&&VolatilitiLow5>0&&VolatilitiLow6>0)
{
   double Array32[2]={VolatilitiUp1,(VolatilitiLow2+VolatilitiLow3+VolatilitiLow4+VolatilitiLow5+VolatilitiLow6)};
   int IndMax=ArrayMaximum(Array32,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array32[IndMax], _Digits);
}
if(VolatilitiLow1==0&&VolatilitiLow2>0&&VolatilitiLow3>0&&VolatilitiLow4>0&&VolatilitiLow5>0&&VolatilitiLow6==0)
{
   double Array33[3]={VolatilitiUp1,(VolatilitiLow2+VolatilitiLow3+VolatilitiLow4+VolatilitiLow5),VolatilitiUp6};
   int IndMax=ArrayMaximum(Array33,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array33[IndMax], _Digits);
}
if(VolatilitiLow1==0&&VolatilitiLow2>0&&VolatilitiLow3>0&&VolatilitiLow4>0&&VolatilitiLow5==0&&VolatilitiLow6>0)
{
   double Array34[4]={VolatilitiUp1,(VolatilitiLow2+VolatilitiLow3+VolatilitiLow4),VolatilitiUp5,VolatilitiLow6};
   int IndMax=ArrayMaximum(Array34,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array34[IndMax], _Digits);
}
if(VolatilitiLow1==0&&VolatilitiLow2>0&&VolatilitiLow3>0&&VolatilitiLow4>0&&VolatilitiLow5==0&&VolatilitiLow6==0)
{
   double Array35[3]={VolatilitiUp1,(VolatilitiLow2+VolatilitiLow3+VolatilitiLow4),(VolatilitiUp5+VolatilitiUp6)};
   int IndMax=ArrayMaximum(Array35,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array35[IndMax], _Digits);
}
if(VolatilitiLow1==0&&VolatilitiLow2>0&&VolatilitiLow3>0&&VolatilitiLow4==0&&VolatilitiLow5>0&&VolatilitiLow6>0)
{
   double Array36[4]={VolatilitiUp1,(VolatilitiLow2+VolatilitiLow3),VolatilitiUp4,(VolatilitiLow5+VolatilitiLow6)};
   int IndMax=ArrayMaximum(Array36,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array36[IndMax], _Digits);
}
if(VolatilitiLow1==0&&VolatilitiLow2>0&&VolatilitiLow3>0&&VolatilitiLow4==0&&VolatilitiLow5>0&&VolatilitiLow6==0)
{
   double Array37[5]={VolatilitiUp1,(VolatilitiLow2+VolatilitiLow3),VolatilitiUp4,VolatilitiLow5,VolatilitiUp6};
   int IndMax=ArrayMaximum(Array37,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array37[IndMax], _Digits);
}
if(VolatilitiLow1==0&&VolatilitiLow2>0&&VolatilitiLow3>0&&VolatilitiLow4==0&&VolatilitiLow5==0&&VolatilitiLow6>0)
{
   double Array38[4]={VolatilitiUp1,(VolatilitiLow2+VolatilitiLow3),(VolatilitiUp4+VolatilitiUp5),VolatilitiLow6};
   int IndMax=ArrayMaximum(Array38,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array38[IndMax], _Digits);
}
if(VolatilitiLow1==0&&VolatilitiLow2>0&&VolatilitiLow3>0&&VolatilitiLow4==0&&VolatilitiLow5==0&&VolatilitiLow6==0)
{
   double Array39[3]={VolatilitiUp1,(VolatilitiLow2+VolatilitiLow3),(VolatilitiUp4+VolatilitiUp5+VolatilitiUp6)};
   int IndMax=ArrayMaximum(Array39,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array39[IndMax], _Digits);
}
if(VolatilitiLow1==0&&VolatilitiLow2>0&&VolatilitiLow3==0&&VolatilitiLow4>0&&VolatilitiLow5>0&&VolatilitiLow6>0)
{
   double Array40[4]={VolatilitiUp1,VolatilitiLow2,VolatilitiUp3,(VolatilitiLow4+VolatilitiLow5+VolatilitiLow6)};
   int IndMax=ArrayMaximum(Array40,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array40[IndMax], _Digits);
}
if(VolatilitiLow1==0&&VolatilitiLow2>0&&VolatilitiLow3==0&&VolatilitiLow4>0&&VolatilitiLow5>0&&VolatilitiLow6==0)
{
   double Array41[5]={VolatilitiUp1,VolatilitiLow2,VolatilitiUp3,(VolatilitiLow4+VolatilitiLow5),VolatilitiUp6};
   int IndMax=ArrayMaximum(Array41,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array41[IndMax], _Digits);
}
if(VolatilitiLow1==0&&VolatilitiLow2>0&&VolatilitiLow3==0&&VolatilitiLow4>0&&VolatilitiLow5==0&&VolatilitiLow6>0)
{
   double Array42[6]={VolatilitiUp1,VolatilitiLow2,VolatilitiUp3,VolatilitiLow4,VolatilitiUp5,VolatilitiLow6};
   int IndMax=ArrayMaximum(Array42,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array42[IndMax], _Digits);
}
if(VolatilitiLow1==0&&VolatilitiLow2>0&&VolatilitiLow3==0&&VolatilitiLow4>0&&VolatilitiLow5==0&&VolatilitiLow6==0)
{
   double Array43[5]={VolatilitiUp1,VolatilitiLow2,VolatilitiUp3,VolatilitiLow4,(VolatilitiUp5+VolatilitiUp6)};
   int IndMax=ArrayMaximum(Array43,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array43[IndMax], _Digits);
}
if(VolatilitiLow1==0&&VolatilitiLow2>0&&VolatilitiLow3==0&&VolatilitiLow4==0&&VolatilitiLow5>0&&VolatilitiLow6>0)
{
   double Array44[4]={VolatilitiUp1,VolatilitiLow2,(VolatilitiUp3+VolatilitiUp4),(VolatilitiLow5+VolatilitiLow6)};
   int IndMax=ArrayMaximum(Array44,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array44[IndMax], _Digits);
}
if(VolatilitiLow1==0&&VolatilitiLow2>0&&VolatilitiLow3==0&&VolatilitiLow4==0&&VolatilitiLow5>0&&VolatilitiLow6==0)
{
   double Array45[5]={VolatilitiUp1,VolatilitiLow2,(VolatilitiUp3+VolatilitiUp4),VolatilitiLow5,VolatilitiUp6};
   int IndMax=ArrayMaximum(Array45,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array45[IndMax], _Digits);
}
if(VolatilitiLow1==0&&VolatilitiLow2>0&&VolatilitiLow3==0&&VolatilitiLow4==0&&VolatilitiLow5==0&&VolatilitiLow6>0)
{
   double Array46[4]={VolatilitiUp1,VolatilitiLow2,(VolatilitiUp3+VolatilitiUp4+VolatilitiUp5),VolatilitiLow6};
   int IndMax=ArrayMaximum(Array46,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array46[IndMax], _Digits);
}
if(VolatilitiLow1==0&&VolatilitiLow2>0&&VolatilitiLow3==0&&VolatilitiLow4==0&&VolatilitiLow5==0&&VolatilitiLow6==0)
{
   double Array47[3]={VolatilitiUp1,VolatilitiLow2,(VolatilitiUp3+VolatilitiUp4+VolatilitiUp5+VolatilitiUp6)};
   int IndMax=ArrayMaximum(Array47,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array47[IndMax], _Digits);
}
if(VolatilitiLow1==0&&VolatilitiLow2==0&&VolatilitiLow3>0&&VolatilitiLow4>0&&VolatilitiLow5>0&&VolatilitiLow6>0)
{
   double Array48[2]={(VolatilitiUp1+VolatilitiUp2),(VolatilitiLow3+VolatilitiLow4+VolatilitiLow5+VolatilitiLow6)};
   int IndMax=ArrayMaximum(Array48,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array48[IndMax], _Digits);
}
if(VolatilitiLow1==0&&VolatilitiLow2==0&&VolatilitiLow3>0&&VolatilitiLow4>0&&VolatilitiLow5>0&&VolatilitiLow6==0)
{
   double Array49[3]={(VolatilitiUp1+VolatilitiUp2),(VolatilitiLow3+VolatilitiLow4+VolatilitiLow5),VolatilitiUp6};
   int IndMax=ArrayMaximum(Array49,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array49[IndMax], _Digits);
}
if(VolatilitiLow1==0&&VolatilitiLow2==0&&VolatilitiLow3>0&&VolatilitiLow4>0&&VolatilitiLow5==0&&VolatilitiLow6>0)
{
   double Array50[4]={(VolatilitiUp1+VolatilitiUp2),(VolatilitiLow3+VolatilitiLow4),VolatilitiUp5,VolatilitiLow6};
   int IndMax=ArrayMaximum(Array50,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array50[IndMax], _Digits);
}
if(VolatilitiLow1==0&&VolatilitiLow2==0&&VolatilitiLow3>0&&VolatilitiLow4>0&&VolatilitiLow5==0&&VolatilitiLow6==0)
{
   double Array51[3]={(VolatilitiUp1+VolatilitiUp2),(VolatilitiLow3+VolatilitiLow4),(VolatilitiUp5+VolatilitiUp6)};
   int IndMax=ArrayMaximum(Array51,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array51[IndMax], _Digits);
}
if(VolatilitiLow1==0&&VolatilitiLow2==0&&VolatilitiLow3>0&&VolatilitiLow4==0&&VolatilitiLow5>0&&VolatilitiLow6>0)
{
   double Array52[4]={(VolatilitiUp1+VolatilitiUp2),VolatilitiLow3,VolatilitiUp4,(VolatilitiLow5+VolatilitiLow6)};
   int IndMax=ArrayMaximum(Array52,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array52[IndMax], _Digits);
}
if(VolatilitiLow1==0&&VolatilitiLow2==0&&VolatilitiLow3>0&&VolatilitiLow4==0&&VolatilitiLow5>0&&VolatilitiLow6==0)
{
   double Array53[5]={(VolatilitiUp1+VolatilitiUp2),VolatilitiLow3,VolatilitiUp4,VolatilitiLow5,VolatilitiUp6};
   int IndMax=ArrayMaximum(Array53,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array53[IndMax], _Digits);
}
if(VolatilitiLow1==0&&VolatilitiLow2==0&&VolatilitiLow3>0&&VolatilitiLow4==0&&VolatilitiLow5==0&&VolatilitiLow6>0)
{
   double Array54[4]={(VolatilitiUp1+VolatilitiUp2),VolatilitiLow3,(VolatilitiUp4+VolatilitiUp5),VolatilitiLow6};
   int IndMax=ArrayMaximum(Array54,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array54[IndMax], _Digits);
}
if(VolatilitiLow1==0&&VolatilitiLow2==0&&VolatilitiLow3>0&&VolatilitiLow4==0&&VolatilitiLow5==0&&VolatilitiLow6==0)
{
   double Array55[3]={(VolatilitiUp1+VolatilitiUp2),VolatilitiLow3,(VolatilitiUp4+VolatilitiUp5+VolatilitiUp6)};
   int IndMax=ArrayMaximum(Array55,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array55[IndMax], _Digits);
}
if(VolatilitiLow1==0&&VolatilitiLow2==0&&VolatilitiLow3==0&&VolatilitiLow4>0&&VolatilitiLow5>0&&VolatilitiLow6>0)
{
   double Array56[2]={(VolatilitiUp1+VolatilitiUp2+VolatilitiUp3),(VolatilitiLow4+VolatilitiLow5+VolatilitiLow6)};
   int IndMax=ArrayMaximum(Array56,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array56[IndMax], _Digits);
}
if(VolatilitiLow1==0&&VolatilitiLow2==0&&VolatilitiLow3==0&&VolatilitiLow4>0&&VolatilitiLow5>0&&VolatilitiLow6==0)
{
   double Array57[3]={(VolatilitiUp1+VolatilitiUp2+VolatilitiUp3),(VolatilitiLow4+VolatilitiLow5),VolatilitiUp6};
   int IndMax=ArrayMaximum(Array57,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array57[IndMax], _Digits);
}
if(VolatilitiLow1==0&&VolatilitiLow2==0&&VolatilitiLow3==0&&VolatilitiLow4>0&&VolatilitiLow5==0&&VolatilitiLow6>0)
{
   double Array58[4]={(VolatilitiUp1+VolatilitiUp2+VolatilitiUp3),VolatilitiLow4,VolatilitiUp5,VolatilitiLow6};
   int IndMax=ArrayMaximum(Array58,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array58[IndMax], _Digits);
}
if(VolatilitiLow1==0&&VolatilitiLow2==0&&VolatilitiLow3==0&&VolatilitiLow4>0&&VolatilitiLow5==0&&VolatilitiLow6==0)
{
   double Array59[3]={(VolatilitiUp1+VolatilitiUp2+VolatilitiUp3),VolatilitiLow4,(VolatilitiUp5+VolatilitiUp6)};
   int IndMax=ArrayMaximum(Array59,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array59[IndMax], _Digits);
}
if(VolatilitiLow1==0&&VolatilitiLow2==0&&VolatilitiLow3==0&&VolatilitiLow4==0&&VolatilitiLow5>0&&VolatilitiLow6>0)
{
   double Array60[2]={(VolatilitiUp1+VolatilitiUp2+VolatilitiUp3+VolatilitiUp4),(VolatilitiLow5+VolatilitiLow6)};
   int IndMax=ArrayMaximum(Array60,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array60[IndMax], _Digits);
}
if(VolatilitiLow1==0&&VolatilitiLow2==0&&VolatilitiLow3==0&&VolatilitiLow4==0&&VolatilitiLow5>0&&VolatilitiLow6==0)
{
   double Array61[3]={(VolatilitiUp1+VolatilitiUp2+VolatilitiUp3+VolatilitiUp4),VolatilitiLow5,VolatilitiUp6};
   int IndMax=ArrayMaximum(Array61,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array61[IndMax], _Digits);
}
if(VolatilitiLow1==0&&VolatilitiLow2==0&&VolatilitiLow3==0&&VolatilitiLow4==0&&VolatilitiLow5==0&&VolatilitiLow6>0)
{
   double Array62[2]={(VolatilitiUp1+VolatilitiUp2+VolatilitiUp3+VolatilitiUp4+VolatilitiUp5),VolatilitiLow6};
   int IndMax=ArrayMaximum(Array62,0,WHOLE_ARRAY);
   Volatiliti=NormalizeDouble(Array62[IndMax], _Digits);
}
if(VolatilitiLow1==0&&VolatilitiLow2==0&&VolatilitiLow3==0&&VolatilitiLow4==0&&VolatilitiLow5==0&&VolatilitiLow6==0)
{
   Volatiliti=NormalizeDouble((VolatilitiUp1+VolatilitiUp2+VolatilitiUp3+VolatilitiUp4+VolatilitiUp5+VolatilitiUp6), _Digits);
}

  MqlTick mqlTick[], symbTick; // объявили переменные
  CopyTicksRange(_Symbol, mqlTick, COPY_TICKS_INFO, symbTick.time_msc, symbTick.time_msc-300); // цены за последний период
  for(int i = 0; i < ArraySize(mqlTick); i++)
  {
     double bid1 = NormalizeDouble(mqlTick[0].bid, _Digits); // первая цена bid за последний период
     double ask1 = NormalizeDouble(mqlTick[0].ask, _Digits); // первая цена ask за последний период
      if(!PositionSelect(Symbol())) // Нет открытых позиций
        {
Print(DoubleToString(VolatilitiUp1,_Digits)," ",DoubleToString(VolatilitiUp2,_Digits)," ",DoubleToString(VolatilitiUp3,_Digits)," ",DoubleToString(VolatilitiUp4,_Digits)," ",DoubleToString(VolatilitiUp5,_Digits)," ",DoubleToString(VolatilitiUp6,_Digits));
Print(DoubleToString(VolatilitiLow1,_Digits)," ",DoubleToString(VolatilitiLow1,_Digits)," ",DoubleToString(VolatilitiLow1,_Digits)," ",DoubleToString(VolatilitiLow1,_Digits)," ",DoubleToString(VolatilitiLow1,_Digits)," ",DoubleToString(VolatilitiLow1,_Digits));
Print("spred=",DoubleToString(spred,_Digits)," Volatiliti=",DoubleToString(Volatiliti,_Digits)," VolatilitiUp1=",DoubleToString(VolatilitiUp1,_Digits)," VolatilitiLow1=",DoubleToString(VolatilitiLow1,_Digits));
            if(spred < 0)
            {
                m_trade.Buy(LotSize,Symbol(),ask0,NULL,NULL,NULL);
                m_trade.Sell(LotSize,Symbol(),bid0,NULL,NULL,NULL);
                Print("2 бай,селл,",DoubleToString(spred,_Digits)," < 0");
            }
            if(spred >= 0 && ((spred*spredVol <= VolatilitiUp1 && VolatilitiLow1 == 0) || spred*spredVol < Volatiliti) && (ask0 > ask1 && bid0 > bid1))
            {
               m_trade.Buy(LotSize,Symbol(),ask0,NULL,NULL,NULL);
Print("2 бай,",DoubleToString(spred,_Digits),">=0 && (",DoubleToString((spred*spredVol),_Digits),"<=",DoubleToString(VolatilitiUp1,_Digits)," && ",DoubleToString(VolatilitiLow1,_Digits),"=0) || ",DoubleToString((spred*spredVol),_Digits),"<",DoubleToString(Volatiliti,_Digits),") && (",DoubleToString(ask0,_Digits),">",DoubleToString(ask1,_Digits)," && ",DoubleToString(bid0,_Digits),">",DoubleToString(bid1,_Digits),")");
            }
            if(spred >= 0 && ((spred*spredVol <= VolatilitiLow1 && VolatilitiUp1 == 0) || spred*spredVol < Volatiliti) && (ask0 < ask1 && bid0 < bid1))
            {
               m_trade.Sell(LotSize,Symbol(),bid0,NULL,NULL,NULL);
Print("3 селл,",DoubleToString(spred,_Digits),">=0 && ((",DoubleToString((spred*spredVol),_Digits),"<=",DoubleToString(VolatilitiLow1,_Digits)," && ",DoubleToString(VolatilitiUp1,_Digits),"=0) || ",DoubleToString((spred*spredVol),_Digits),"<",DoubleToString(Volatiliti,_Digits),") && (",DoubleToString(ask0,_Digits),"<",DoubleToString(ask1,_Digits)," && ",DoubleToString(bid0,_Digits),"<",DoubleToString(bid1,_Digits),")");
            }
        }
        if(PositionSelect(Symbol())) // Есть открытые позиции
        {
            //Print("Есть открытые позиции");
            if(spred < 0 && Type == POSITION_TYPE_BUY && bid0 > Price)
            {
               Print("1 spred < 0 && Type == POSITION_TYPE_BUY && bid0 > Price");
               if(m_trade.PositionClose(m_position_ticket)) Print("1 закрыли");
            }
            if(spred < 0 && Type == POSITION_TYPE_SELL && ask0 < Price)
            {
               Print("2 spred < 0 && Type == POSITION_TYPE_SELL && ask0 < Price");
               if(m_trade.PositionClose(m_position_ticket)) Print("2 закрыли");
            }
            if(spred >= 0 && Type == POSITION_TYPE_BUY && (bid0 + spred < bid1 || ask0 + spred < ask1))
            {
               Print("3 spred>0,BUY,",DoubleToString((bid0+spred),_Digits)," < ",DoubleToString(bid1,_Digits),"||",DoubleToString((ask0+spred),_Digits)," < ",DoubleToString(ask1,_Digits));
               if(m_trade.PositionClose(m_position_ticket)) Print("3 закрыли");
            }
            if(spred >= 0 && Type == POSITION_TYPE_SELL && (ask0 > ask1 + spred || bid0 > bid1 + spred))
            {
               Print("4 spred>0,SELL,",DoubleToString(ask0,_Digits)," > ",DoubleToString((ask1 + spred),_Digits),"||",DoubleToString(bid0,_Digits)," > ",DoubleToString((bid1 + spred),_Digits));
               if(m_trade.PositionClose(m_position_ticket)) Print("4 закрыли");
            }
        }
     }
}

//+------------------------------------------------------------------+
//| Refreshes the symbol quotes data                                 |
//+------------------------------------------------------------------+
bool RefreshRates(void)
  {
   if(!m_symbol.RefreshRates())
     {
      Print("RefreshRates error");
      return(false);
     }
//--- protection against the return value of "zero"
   if(m_symbol.Ask()==0 || m_symbol.Bid()==0)
      return(false);
//---
   return(true);
  }

//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
{
   EventKillTimer();
}
